/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

$.support.cors = true;

var app = {

    // Variables globales

    preguntas : '',
    map : '',
    map_seleccionar : '',
    foto : '',
    arrPuntos : [],

    // Application Constructor
    initialize: function() {
        this.bindEvents();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
       // document.addEventListener('deviceready', this.onDeviceReady, false);
        app.onDeviceReady();
    },
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicitly call 'app.receivedEvent(...);'
    onDeviceReady: function() {
      //  localStorage.clear();

        if(!localStorage['file_lang']) {
            localStorage.setItem('file_lang', 'es');       
        }

        if(!localStorage['idioma']) {
            localStorage.setItem('idioma', app.getLanguage() || 'en');

            if(localStorage['idioma']!= "es" && localStorage['idioma']!= "en" && localStorage['idioma']!= "eu") {
                localStorage.setItem('idioma', "en");
            }
        }
        //alert(localStorage['idioma']);


        if(localStorage['idioma']!=localStorage['file_lang'])
        {
            localStorage.setItem('file_lang', localStorage['idioma']); 
            if(localStorage['idioma']=='es')
            {
                window.location='./index.html';
            }
            else
            {
               window.location='./index-'+localStorage['idioma']+'.html'; 
            }
        }

        //localStorage.clear();

        //alert(window.location);

        $("#btnContinuarInicio").bind("click",app.cargarDatos);
        $("#btnContinuarInicio").bind("click",app.comprobarDatosUsuario);
        $("#ano_ncto").attr("max", app.obtenerAnoNctoMax());
        $("#btnContinuarDatos").bind("click", app.comprobarCampos);
        //$("#btnContinuarDatos").bind("click", app.guardarDatosUsuario);
        $("#residencia").bind("change", app.seleccionarLugarResidencia);
        $("#btnDatos").bind("click", app.modificarDatosUsuario);
        $("#btnAhora").bind("click", app.obtenerCoordenadas);
        $("#btnFinalizar").bind("click", app.enviarResultados);
        $("#btnSacarFoto").bind("click", app.accederCamara);
        $("#btnGaleria").bind("click", app.accederGaleria);
        $("#btnContinuar_otroMomento").bind("click", app.comprobarHorasYMinutos);
        $("#btnVerMapa").bind("click", app.visualizarMapa);
        $("#btnIdioma").bind("click", app.modificarIdioma);
        $("#btnContinuar_idioma").bind("click", app.guardarIdioma);
        $("#btnContinuar_otroMomento").bind("click", app.actualizarHorasYMinutos);
        $("#btnOtroMomento").bind("click", app.mostrarMapaSeleccionar);
    },
    mostrarMapaSeleccionar : function() {
        
        navigator.geolocation.getCurrentPosition(function(pos) {

            setTimeout(function(){ 
                app.map_seleccionar = new google.maps.Map(document.getElementById('mapa_seleccionar'),{
                    center: {lat: pos.coords.latitude, lng: pos.coords.longitude},
                    scrollwheel: false,
                    zoom: 15
                });

                var marker2 = new google.maps.Marker({
                    position: {lat: pos.coords.latitude, lng: pos.coords.longitude}, 
                    //icon: "http://google-maps-icons.googlecode.com/files/info.png",
                    draggable: true
                });
                $("#lat").val(pos.coords.latitude);
                $("#long").val(pos.coords.longitude);

                app.getLocalidad(pos.coords.latitude,pos.coords.longitude,function(pueblo){
                    $("#localidad").val(pueblo);
                    //alert(pueblo);
                })
               
                
                // Le asignamos el mapa a los marcadores.
                marker2.setMap(app.map_seleccionar);
                google.maps.event.addListener(marker2, 'dragend', function() {
                    $("#lat").val(marker2.getPosition().lat());
                    
                    
                    $("#long").val(marker2.getPosition().lng());
        
                    app.getLocalidad(marker2.getPosition().lat(),marker2.getPosition().lng(),function(pueblo){
                        $("#localidad").val(pueblo);
                        //alert(pueblo);
                    })
                });
            }, 1000);            
        });
    },
    getAddressComponent: function(address,component)
    {
         var components = address[0]['address_components'];
         
         for (var i in components)
         {
         if(components[i]['types'].indexOf(component)>-1)
         {
         return components[i]['long_name'];
         }
         }
         return false;
    },
    // Update DOM on a Received Event
    receivedEvent: function() {
        
    },
    cargarDatos: function() {
       //alert("estoy entrando");
       //var data = [{"idpregunta":"1","numpregunta":"1","enunciado":"\u00bfEn ese lugar y momento, c\u00f3mo te sientes\/te has sentido?","tiporesp":"escala","respuestas":[{"idrespuesta":"1","textoresp":"Muy inseguro"},{"idrespuesta":"2","textoresp":"Muy seguro"}]},{"idpregunta":"2","numpregunta":"2","enunciado":"\u00bfPor qu\u00e9 te sientes\/has sentido as\u00ed?","tiporesp":"checkbox","respuestas":[{"idrespuesta":"3","textoresp":"Por el aspecto del lugar (estrecho, poca visibilidad...)"},{"idrespuesta":"4","textoresp":"Por la falta de luz"},{"idrespuesta":"5","textoresp":"Por el tipo de gente que hay"},{"idrespuesta":"6","textoresp":"Porque no hay nadie a esta hora"}]},{"idpregunta":"3","numpregunta":"3","enunciado":"\u00bfPor qu\u00e9 est\u00e1s\/estabas en ese lugar?","tiporesp":"radiobutton","respuestas":[{"idrespuesta":"7","textoresp":"Haciendo mi trabajo"},{"idrespuesta":"8","textoresp":"Yendo al trabajo o volviendo a casa"},{"idrespuesta":"9","textoresp":"Compras, ocio, paseo..."}]},{"idpregunta":"4","numpregunta":"4","enunciado":"Est\u00e1s\/estabas:","tiporesp":"radiobutton","respuestas":[{"idrespuesta":"10","textoresp":"Solo\/a"},{"idrespuesta":"11","textoresp":"Con otras personas"}]},{"idpregunta":"5","numpregunta":"5","enunciado":"Debido a c\u00f3mo te has sentido, \u00bfte has marchado del lugar o cambiado tu ruta? ","tiporesp":"radiobutton","respuestas":[{"idrespuesta":"12","textoresp":"S\u00ed"},{"idrespuesta":"13","textoresp":"No"}]},{"idpregunta":"6","numpregunta":"6","enunciado":"En el futuro:","tiporesp":"radiobutton","respuestas":[{"idrespuesta":"14","textoresp":"No vendr\u00e9 a este lugar, evitar\u00e9 pasar"},{"idrespuesta":"15","textoresp":"Vendr\u00e9 o pasar\u00e9, pero no a esta hora"},{"idrespuesta":"16","textoresp":"Seguir\u00e9 viniendo o pasando por este lugar"}]}];
       var idioma = window.localStorage['idioma'];
       //app.crearPaginaPreguntas(data);
        $.ajax({
            url: "http://city4all.xyz/City4All/es/prueba3.php",
            //url: "http://localhost/City4All/es/prueba3.php",
            data: { idioma : idioma },
            //type : 'GET',
            jsonp: "callback",
            dataType: "jsonp",
            success: function(data) {
                //alert(data[1]['enunciado']);
                app.crearPaginaPreguntas(data);

            },
            error: function(xhr, status, text) {
                alert($.parseJSON(xhr.responseText));
            }
        })
    },
    obtenerAnoNctoMax: function() {
        return (new Date).getFullYear()-18;
    },
    utf8_decode : function(str_data) {
      //  discuss at: http://phpjs.org/functions/utf8_decode/
      // original by: Webtoolkit.info (http://www.webtoolkit.info/)
      //    input by: Aman Gupta
      //    input by: Brett Zamir (http://brett-zamir.me)
      // improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
      // improved by: Norman "zEh" Fuchs
      // bugfixed by: hitwork
      // bugfixed by: Onno Marsman
      // bugfixed by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
      // bugfixed by: kirilloid
      //   example 1: utf8_decode('Kevin van Zonneveld');
      //   returns 1: 'Kevin van Zonneveld'

      var tmp_arr = [],
        i = 0,
        ac = 0,
        c1 = 0,
        c2 = 0,
        c3 = 0,
        c4 = 0;

      str_data += '';

      while (i < str_data.length) {
        c1 = str_data.charCodeAt(i);
        if (c1 <= 191) {
          tmp_arr[ac++] = String.fromCharCode(c1);
          i++;
        } else if (c1 <= 223) {
          c2 = str_data.charCodeAt(i + 1);
          tmp_arr[ac++] = String.fromCharCode(((c1 & 31) << 6) | (c2 & 63));
          i += 2;
        } else if (c1 <= 239) {
          // http://en.wikipedia.org/wiki/UTF-8#Codepage_layout
          c2 = str_data.charCodeAt(i + 1);
          c3 = str_data.charCodeAt(i + 2);
          tmp_arr[ac++] = String.fromCharCode(((c1 & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
          i += 3;
        } else {
          c2 = str_data.charCodeAt(i + 1);
          c3 = str_data.charCodeAt(i + 2);
          c4 = str_data.charCodeAt(i + 3);
          c1 = ((c1 & 7) << 18) | ((c2 & 63) << 12) | ((c3 & 63) << 6) | (c4 & 63);
          c1 -= 0x10000;
          tmp_arr[ac++] = String.fromCharCode(0xD800 | ((c1 >> 10) & 0x3FF));
          tmp_arr[ac++] = String.fromCharCode(0xDC00 | (c1 & 0x3FF));
          i += 4;
        }
      }

      return tmp_arr.join('');
    },
    /*
    decode_utf8 : function(s) {
        return decodeURIComponent(escape(s));
    },
    */
    crearPaginaPreguntas: function(datos) {
        //alert(datos.length);

        app.preguntas = datos;
        var pregunta = '';
        for(var i = 0; i < datos.length; i++) {
            pregunta+='<div data-role="page" id="pregunta_'+(i+1)+'">';

                pregunta+='<div data-role="header">';
                if(window.localStorage["idioma"] == "es") {
                    pregunta+='<p>Pregunta '+(i+1)+' de '+datos.length+'</p>';
                } else if(window.localStorage["idioma"] == "en") {
                    pregunta+='<p>Question '+(i+1)+' of '+datos.length+'</p>';
                } else if(window.localStorage["idioma"] == "eu") {
                    pregunta+='<p>'+datos.length+' galderetatik '+(i+1)+'. galdera</p>';
                }
                    
                    /*
                    for(k = 0; k < datos.length; k++) {
                        if(k == i){
                            pregunta+='<p data-type="horizontal" style="color: #72BB53" data-inline="true">'+(k+1)+'   </p>';
                        } else {
                            pregunta+='<p data-inline="true">'+(k+1)+'   </p>';
                        }
                    }
                    */
                pregunta+='</div>';

                pregunta+='<div data-role="main" class="ui-content">';
                    pregunta+='<p>'+datos[i].enunciado+'</p>';  

                    if(datos[i].tiporesp == "escala") {
                        pregunta+='<fieldset data-role="controlgroup" data-type="horizontal" class="ui-field-contain">';
                            pregunta+='<p style="text-align: center">'+datos[i].respuestas[0].textoresp+'</p>';
                            for(var j = 1; j <= 5; j++) {
                                pregunta+='<label for="'+j+'">'+j+'</label>';
                                pregunta+='<input type="radio" name="preg_'+datos[i].idpregunta+'" id="'+j+'" value="'+j+'" class="dato">';
                            }
                            pregunta+='<p style="text-align: center">'+datos[i].respuestas[1].textoresp+'</p>';
                        pregunta+='</fieldset>';
                    } else {
                        if(datos[i].tiporesp == "radiobutton") {
                            for(var j = 0; j < datos[i].respuestas.length; j++) {
                                pregunta+='<label for="'+datos[i].respuestas[j].idrespuesta+'">'+datos[i].respuestas[j].textoresp+'</label>';
                                pregunta+='<input type="radio" name="preg_'+datos[i].idpregunta+'" id="'+datos[i].respuestas[j].idrespuesta+'" value="'+datos[i].respuestas[j].idrespuesta+'" class="dato">';
                            }
                        } else {
                            if(datos[i].tiporesp == "checkbox") {
                                for(var j = 0; j < datos[i].respuestas.length; j++) {
                                    //pregunta+='<input type="checkbox" name="'+datos[i].respuestas[j].idrespuesta+'" id="'+datos[i].respuestas[j].idrespuesta+'" value="'+datos[i].respuestas[j].idrespuesta+'">'+datos[i].respuestas[j].textoresp;
                                    pregunta+='<label for="idresp'+datos[i].respuestas[j].idrespuesta+'">'+datos[i].respuestas[j].textoresp+'</label>';
                                    //pregunta+='<input type="checkbox" name="preg_'+datos[i].idpregunta+'_resp_'+datos[i].respuestas[j].idrespuesta+'" id="idresp_'+datos[i].respuestas[j].idrespuesta+'" value="'+datos[i].respuestas[j].idrespuesta+'" class="dato">';
                                    pregunta+='<input type="checkbox" name="preg_'+datos[i].idpregunta+'[]" id="idresp'+datos[i].respuestas[j].idrespuesta+'" value="'+datos[i].respuestas[j].idrespuesta+'" class="dato">';
                                }
                            } else {
                                pregunta+='<textarea rows="4" cols="30" name="preg_'+datos[i].idpregunta+'" class="dato"></textarea>';
                                /*
                                <label for="info">Additional Information:</label>
                                <textarea name="addinfo" id="info"></textarea>
                                */
                            }
                        }
                    }

                    pregunta+='<div data-role="footer">';
                        pregunta+='<div class="ui-grid-a ui-responsive">'; //http://www.w3schools.com/jquerymobile/jquerymobile_grids.asp
                            if(i != 0) {
                                pregunta+='<div class="ui-block-a">'; //http://www.w3schools.com/jquerymobile/jquerymobile_grids.asp
                                    if(window.localStorage["idioma"] == "es") {
                                        pregunta+='<a href="#pregunta_'+(i)+'" data-transition="slide" data-direction="reverse" class="ui-btn ui-corner-all ui-btn-inline" id="btnAnterior">Anterior</a>';
                                    } else if(window.localStorage["idioma"] == "en") {
                                        pregunta+='<a href="#pregunta_'+(i)+'" data-transition="slide" data-direction="reverse" class="ui-btn ui-corner-all ui-btn-inline" id="btnAnterior">Back</a>';
                                    } else if(window.localStorage["idioma"] == "eu") {
                                        pregunta+='<a href="#pregunta_'+(i)+'" data-transition="slide" data-direction="reverse" class="ui-btn ui-corner-all ui-btn-inline" id="btnAnterior">Aurrekoa</a>';
                                    }
                                pregunta+='</div>';
                            }
                            if(i != datos.length-1) {
                                pregunta+='<div class="ui-block-b">';
                                    if(window.localStorage["idioma"] == "es") {
                                        pregunta+='<a href="#pregunta_'+(i+2)+'" data-transition="slide" class="ui-btn ui-corner-all ui-btn-inline" id="btnSiguiente" text-align="right">Siguiente</a>';
                                    } else if(window.localStorage["idioma"] == "en") {
                                        pregunta+='<a href="#pregunta_'+(i+2)+'" data-transition="slide" class="ui-btn ui-corner-all ui-btn-inline" id="btnSiguiente" text-align="right">Next</a>';
                                    } else if(window.localStorage["idioma"] == "eu") {
                                        pregunta+='<a href="#pregunta_'+(i+2)+'" data-transition="slide" class="ui-btn ui-corner-all ui-btn-inline" id="btnSiguiente" text-align="right">Hurrengoa</a>';
                                    }
                                pregunta+='</div>';
                            } else {
                                pregunta+='<div class="ui-block-b">';
                                    if(window.localStorage["idioma"] == "es") {
                                        pregunta+='<a href="#page_foto" data-transition="slide" class="ui-btn ui-corner-all ui-btn-inline" id="btnSiguiente" text-align="right">Siguiente</a>';
                                    } else if(window.localStorage["idioma"] == "en") {
                                        pregunta+='<a href="#page_foto" data-transition="slide" class="ui-btn ui-corner-all ui-btn-inline" id="btnSiguiente" text-align="right">Next</a>';
                                    } else if(window.localStorage["idioma"] == "eu") {
                                        pregunta+='<a href="#page_foto" data-transition="slide" class="ui-btn ui-corner-all ui-btn-inline" id="btnSiguiente" text-align="right">Hurrengoa</a>';
                                    }
                                pregunta+='</div>';
                            }
                        pregunta+='</div>';
                    pregunta+='</div>';
                pregunta+='</div>';
            pregunta+='</div>';
        }
        //alert(pregunta);
        $('#contenedor').append(pregunta);
    },
    comprobarCampos: function() {
        //alert($("#lista-municipios").val());
        //alert($('input:radio[name=sexo]:checked').val());
        if($('input:radio[name=sexo]:checked').val() == undefined) {
            return false;
        }
        if($.trim($('#ano_ncto').val()) == '') {
            return false;
        }
        if($("#residencia").val() == 'espana') {
            if(($("#lista-municipios").val() == 0 || $("#lista-municipios").val() == null)) {
                return false;

            }
        } else {
            if($.trim($('#resid-extranjera').val()) == '') {
                return false;
            }
        }
        app.guardarDatosUsuario();
        return true;
    },
    comprobarHorasYMinutos: function() {
        if($.trim($('#horas').val()) == '' || $.trim($('#minutos').val()) == '') {
            alert("Tienes que introducir hace cuánto tiempo ha ocurrido la experiencia. Máximo: 12 horas");
            return false;
        }
        if($.trim($('#horas').val()) < 0 || $.trim($('#horas').val()) > 11 || $.trim($('#minutos').val()) < 0 || $.trim($('#minutos').val()) > 59) {
            alert("Se pueden introducir experiencias ocurridas hace 12 horas como máximo.");
            return false;
        }
        return true;
    },
    seleccionarLugarResidencia: function() {
        //alert($("#residencia").val());
        if($("#residencia").val() == 'espana') {
            app.obtenerProvincias();
        } else {
            if($("#residencia").val() == 'extranjero') {
                $('#contenedor_provincias').css('display', 'none');
                $('#contenedor_municipios').css('display', 'none');
                $('#lugar-residencia').css('display', 'block');
            } else {
                $('#contenedor_provincias').css('display', 'none');
                $('#contenedor_municipios').css('display', 'none');
                $('#lugar-residencia').css('display', 'none');
            }
        }
    },
    obtenerProvincias: function(callback) {
       //alert("estoy entrando");
       //var data = [{"idpregunta":"1","numpregunta":"1","enunciado":"\u00bfEn ese lugar y momento, c\u00f3mo te sientes\/te has sentido?","tiporesp":"escala","respuestas":[{"idrespuesta":"1","textoresp":"Muy inseguro"},{"idrespuesta":"2","textoresp":"Muy seguro"}]},{"idpregunta":"2","numpregunta":"2","enunciado":"\u00bfPor qu\u00e9 te sientes\/has sentido as\u00ed?","tiporesp":"checkbox","respuestas":[{"idrespuesta":"3","textoresp":"Por el aspecto del lugar (estrecho, poca visibilidad...)"},{"idrespuesta":"4","textoresp":"Por la falta de luz"},{"idrespuesta":"5","textoresp":"Por el tipo de gente que hay"},{"idrespuesta":"6","textoresp":"Porque no hay nadie a esta hora"}]},{"idpregunta":"3","numpregunta":"3","enunciado":"\u00bfPor qu\u00e9 est\u00e1s\/estabas en ese lugar?","tiporesp":"radiobutton","respuestas":[{"idrespuesta":"7","textoresp":"Haciendo mi trabajo"},{"idrespuesta":"8","textoresp":"Yendo al trabajo o volviendo a casa"},{"idrespuesta":"9","textoresp":"Compras, ocio, paseo..."}]},{"idpregunta":"4","numpregunta":"4","enunciado":"Est\u00e1s\/estabas:","tiporesp":"radiobutton","respuestas":[{"idrespuesta":"10","textoresp":"Solo\/a"},{"idrespuesta":"11","textoresp":"Con otras personas"}]},{"idpregunta":"5","numpregunta":"5","enunciado":"Debido a c\u00f3mo te has sentido, \u00bfte has marchado del lugar o cambiado tu ruta? ","tiporesp":"radiobutton","respuestas":[{"idrespuesta":"12","textoresp":"S\u00ed"},{"idrespuesta":"13","textoresp":"No"}]},{"idpregunta":"6","numpregunta":"6","enunciado":"En el futuro:","tiporesp":"radiobutton","respuestas":[{"idrespuesta":"14","textoresp":"No vendr\u00e9 a este lugar, evitar\u00e9 pasar"},{"idrespuesta":"15","textoresp":"Vendr\u00e9 o pasar\u00e9, pero no a esta hora"},{"idrespuesta":"16","textoresp":"Seguir\u00e9 viniendo o pasando por este lugar"}]}];
       
       //app.crearPaginaPreguntas(data);
        try {
            $.ajax({
            
                url: "http://city4all.xyz/City4All/es/obtener-provincias.php",
                //url: "http://localhost/City4All/es/obtener-provincias.php",
                jsonp: "callback",
                dataType: "jsonp",
                success: function(data) {
                    $('#lista-provincias').append('<option value="0" selected>Provincia</option>');
                    for(var i in data) {
                        //$('#lista-provincias').append('<li><a href="#" onclick="app.obtenerMunicipios(\''+data[i].idprovincia+'\')">'+data[i].provincia+'</a></li>');                        
                        $('#lista-provincias').append('<option value="'+data[i].idprovincia+'">'+data[i].provincia+'</option>');
                    }
                    $('#lugar-residencia').css('display', 'none');
                    $('#contenedor_provincias').css('display', 'block');

                    if(callback)
                    {
                        callback();
                    }
                },
                error: function(xhr, status, text) {
                    //for(var i in xhr) {
                        alert(xhr.status);
                    //}
                    
                }
            })
        } catch(e) {
            alert(e);
        }
    },
    getIdProvicia : function (nombre)
    {
        for (var i in app.provincias)
        {
            if(app.provincias[i].provincia == nombre)
            {
                return app.provincias[i].idprovincia;
            }
        }

        return false;
    },
    obtenerMunicipios: function(idprovincia, callback) {
       //alert("estoy entrando");
       //var data = [{"idpregunta":"1","numpregunta":"1","enunciado":"\u00bfEn ese lugar y momento, c\u00f3mo te sientes\/te has sentido?","tiporesp":"escala","respuestas":[{"idrespuesta":"1","textoresp":"Muy inseguro"},{"idrespuesta":"2","textoresp":"Muy seguro"}]},{"idpregunta":"2","numpregunta":"2","enunciado":"\u00bfPor qu\u00e9 te sientes\/has sentido as\u00ed?","tiporesp":"checkbox","respuestas":[{"idrespuesta":"3","textoresp":"Por el aspecto del lugar (estrecho, poca visibilidad...)"},{"idrespuesta":"4","textoresp":"Por la falta de luz"},{"idrespuesta":"5","textoresp":"Por el tipo de gente que hay"},{"idrespuesta":"6","textoresp":"Porque no hay nadie a esta hora"}]},{"idpregunta":"3","numpregunta":"3","enunciado":"\u00bfPor qu\u00e9 est\u00e1s\/estabas en ese lugar?","tiporesp":"radiobutton","respuestas":[{"idrespuesta":"7","textoresp":"Haciendo mi trabajo"},{"idrespuesta":"8","textoresp":"Yendo al trabajo o volviendo a casa"},{"idrespuesta":"9","textoresp":"Compras, ocio, paseo..."}]},{"idpregunta":"4","numpregunta":"4","enunciado":"Est\u00e1s\/estabas:","tiporesp":"radiobutton","respuestas":[{"idrespuesta":"10","textoresp":"Solo\/a"},{"idrespuesta":"11","textoresp":"Con otras personas"}]},{"idpregunta":"5","numpregunta":"5","enunciado":"Debido a c\u00f3mo te has sentido, \u00bfte has marchado del lugar o cambiado tu ruta? ","tiporesp":"radiobutton","respuestas":[{"idrespuesta":"12","textoresp":"S\u00ed"},{"idrespuesta":"13","textoresp":"No"}]},{"idpregunta":"6","numpregunta":"6","enunciado":"En el futuro:","tiporesp":"radiobutton","respuestas":[{"idrespuesta":"14","textoresp":"No vendr\u00e9 a este lugar, evitar\u00e9 pasar"},{"idrespuesta":"15","textoresp":"Vendr\u00e9 o pasar\u00e9, pero no a esta hora"},{"idrespuesta":"16","textoresp":"Seguir\u00e9 viniendo o pasando por este lugar"}]}];
       
       //app.crearPaginaPreguntas(data);
        if($('#lista-provincias').val() != 0) {
            $.ajax({
                url: "http://city4all.xyz/City4All/es/obtener-municipios.php",
                //url: "http://localhost/City4All/es/obtener-municipios.php",
                data: { id_provincia : idprovincia },
                //type : 'GET',
                jsonp: "callback",
                dataType: "jsonp",
                success: function(data) {
                    //alert(data);
                    //app.crearPaginaPreguntas(data);
                    $('#lista-municipios').html('');
                    $('#lista-municipios').append('<option value="0" selected>Municipio</option>');
                    for(var i in data) {
                        //$('#lista-provincias').append('<li><a href="#" onclick="app.obtenerMunicipios(\''+data[i].idprovincia+'\')">'+data[i].provincia+'</a></li>');                        
                        $('#lista-municipios').append('<option value="'+data[i].idmunicipio+'">'+data[i].municipio+'</option>');
                    }
                    $('#contenedor_municipios').css('display', 'block');

                    if(callback)
                    {
                        callback();
                    }

                },
                error: function(xhr, status, text) {
                    alert($.parseJSON(xhr.responseText));
                }
            })
        } else {
            $('#contenedor_municipios').css('display', 'none');
        }       
    },
    guardarDatosUsuario : function() {
        //if($('input:radio[name=sexo]:checked').val() == "mujer") {
        localStorage.setItem("sexo", $('input:radio[name=sexo]:checked').val());
        /*} else {
            localStorage.setItem("sexo", "hombre");
        }*/

        if($.trim($('#ano_ncto').val()) != '') {
            localStorage.setItem("ano_ncto", $.trim($('#ano_ncto').val()));
        }
        
        if($("#residencia").val() == 'espana') {
            localStorage.setItem("pais", $('#residencia').val());
            
            localStorage.setItem("provincia", $('#lista-provincias').val());

            localStorage.setItem("idmunicipio", $('#lista-municipios').val());
            localStorage.setItem("municipio", $('#lista-municipios option:selected').html());
            
        } else {
            localStorage.setItem("pais", $('#residencia').val());
            localStorage.setItem("municipio", $('#resid-extranjera').val());
        }
        //console.log($('input:radio[name=sexo]:checked').val());
        //console.log($.trim($('#ano_ncto').val()));
        //console.log($('#resid-extranjera').val());
    },
    comprobarDatosUsuario : function() {
        if(localStorage['sexo']) {
            window.location.href = "#page_menu";
        } else {
            window.location.href = "#page_datos";
        }
        return false;
    },
    modificarDatosUsuario : function() {
        if(window.localStorage["sexo"] == "hombre") {
            $('#sexo-hombre').prop('checked', true);
        } else {
            $('#sexo-mujer').prop('checked', true);
        }

        $('#ano_ncto').val(window.localStorage["ano_ncto"]);

        if(window.localStorage["pais"] == "espana") {
            //alert("estoy entrando españa");
            $('#residencia option[value="'+window.localStorage["pais"]+'"]').prop('selected', true);
            //alert(window.localStorage["pais"]);
            $('#contenedor_provincias').css('display', 'block');
            app.obtenerProvincias(function(){
                //alert('aqui');
                //setTimeout(function(){
                    $('#lista-provincias option[value="'+window.localStorage["provincia"]+'"]').prop('selected', true);
                    $('#lista-provincias').val(window.localStorage["provincia"]);
                    $('#lista-provincias').selectmenu('refresh');
                    //alert(window.localStorage["provincia"]);
                //},1000);
            });
          
            app.obtenerMunicipios(window.localStorage["provincia"],function(){
                //alert('aqui');
                //setTimeout(function(){
                    $('#contenedor_municipios').css('display', 'block');
                    $('#lista-municipios option[value="'+window.localStorage["idmunicipio"]+'"]').prop('selected', true);
                    $('#lista-municipios').selectmenu('refresh');
                    //alert(window.localStorage["provincia"]);
                //},1000);
            });

        } else {
            //alert("estoy entrando extranjero");
            $('#contenedor_provincias').css('display', 'none');
            $('#contenedor_municipios').css('display', 'none');
            $('#resid-extranjera').css('display', 'block');

            $('#resid-extranjera').val(window.localStorage["municipio"]);
            $('#resid-extranjera').textinput("refresh");
        }
        //alert(window.localStorage["municipio"]);
    },
    obtenerCoordenadas : function() {
        navigator.geolocation.getCurrentPosition(function(pos) {
            
            $("#lat").val(pos.coords.latitude);
            $("#long").val(pos.coords.longitude);

            app.getLocalidad(pos.coords.latitude,pos.coords.longitude,function(pueblo){
                $("#localidad").val(pueblo);
            })
        });
        //window.location.href="#pregunta_1";

    },
    
    getLocalidad : function (lat,lon,callback)
    {
            var geocoder = new google.maps.Geocoder();
            
            geocoder.geocode({'latLng' : new google.maps.LatLng(lat, lon)}, function(results, status) {
                if (status == google.maps.GeocoderStatus.OK) {
                    var localidad = app.getAddressComponent(results, 'locality');
                    callback(localidad);
                }
            });

    },
    visualizarMapa : function() {
        navigator.geolocation.getCurrentPosition(function(pos) {
          
            setTimeout(function(){ 
                app.map = new  google.maps.Map(document.getElementById('mapa'),{
                    center: {lat: pos.coords.latitude, lng: pos.coords.longitude},
                    scrollwheel: false,
                    zoom: 15
                });



            var marker1 = new google.maps.Marker({
                position: {lat: pos.coords.latitude, lng: pos.coords.longitude}, 
                icon: "http://maps.google.com/mapfiles/ms/icons/blue-dot.png",
                draggable: false
            });
            // Le asignamos el mapa a los marcadores.
            marker1.setMap(app.map);
        

            app.map.setCenter({lat: pos.coords.latitude, lng: pos.coords.longitude});
            
            app.getLocalidad(pos.coords.latitude,pos.coords.longitude,function(localidad){

                $.ajax({
                    url: "http://city4all.xyz/City4All/es/obtener-puntos.php",
                    //url: "http://localhost/City4All/es/enviar-resultados.php",
                    data: { ubicacion : localidad },
                    //type : 'GET',
                    jsonp: "callback",
                    dataType: "jsonp",
                    success: function(puntos) {
                      //alert(' aaa'+puntos);
                      for(var i in puntos) {

                        app.arrPuntos[i] = puntos[i];
                       //alert( puntos[i]['latitud']+' - '+puntos[i]['longitud']);
                        if(puntos[i]['codigo'] < 3) {
                            var marker = new google.maps.Marker({
                                position: {lat: puntos[i]['latitud'], lng: puntos[i]['longitud']}, 
                                map: app.map,
                                icon: "http://maps.google.com/mapfiles/ms/icons/red-dot.png",
                                draggable: false
                            });  
                        } else if (puntos[i]['codigo'] == 3) {
                            var marker = new google.maps.Marker({
                                position: {lat: puntos[i]['latitud'], lng: puntos[i]['longitud']}, 
                                map: app.map,
                                icon: "http://maps.google.com/mapfiles/ms/icons/yellow-dot.png",
                                draggable: false
                            });  
                        } else {
                            var marker = new google.maps.Marker({
                                position: {lat: puntos[i]['latitud'], lng: puntos[i]['longitud']}, 
                                map: app.map,
                                icon: "http://maps.google.com/mapfiles/ms/icons/green-dot.png",
                                draggable: false
                            }); 
                        }

                         
                      }
                    },
                    error: function(xhr, status, text) {
                        //alert(text);
                    }
                })
             })

            }, 1000);

          
        }, function(){
            navigator.notification.alert('No_se_ha_podido_obtener_la_direccion_actual_comprueba_la_conexión_a_internet_e_intentalo_de_nuevo');
        })
    },
    actualizarHorasYMinutos : function() {
        $("#horas_a_restar").val($("#horas").val());
        $("#minutos_a_restar").val($("#minutos").val());
    },
    enviarResultados : function() {
        var arrDatos = new Object();
        
        var fecha_hora = new Date();

        var segundos = fecha_hora.getSeconds();
        var minutos = fecha_hora.getMinutes() - $("#minutos_a_restar").val();
        var hora = fecha_hora.getHours() - $("#horas_a_restar").val();
        var dia = fecha_hora.getDate();
        var mes = fecha_hora.getMonth() + 1;
        var anyo = fecha_hora.getFullYear();

        if(segundos < 10) {
            segundos = "0" + segundos;
        }
        
        if(minutos < 0) {
            minutos = minutos + 60;
            hora = hora - 1;
        }
        if(minutos < 10) {
            minutos = "0" + minutos;
        }
        
        /*alert('hora actual: ' + fecha_hora.getHours());
        alert('horas a restar: ' + $("#horas_a_restar").val());
        alert('hora a guardar: ' + hora);

        alert('minuto actual: ' + fecha_hora.getMinutes());
        alert('minutos a restar: ' + $("#minutos_a_restar").val());
        alert('minuto a guardar: ' + minutos);*/
        if(hora < 0) {
            hora = hora + 24;
            dia = dia - 1;
        }
        if(hora < 10) {
            hora = "0" + hora;
        }
        
        if(dia == 0) {
            mes = mes - 1;
            if(mes == 1 || mes == 3 || mes == 5 || mes == 7 || mes == 8 || mes == 10 || mes == 12) {
                dia = 31;
            } else if (mes == 4 || mes == 6 || mes == 9 || mes == 11) {
                dia = 30;
            } else if(anyo % 4 == 0) {
                dia = 29;
            } else {
                dia = 28;
            }
        }
        if(dia < 10) {
            dia = "0" + dia;
        }
        
        if(mes == 0) {
            mes = 12;
            anyo = anyo - 1;
        }
        if(mes < 10) {
            mes = "0" + mes;
        }    

        arrDatos['sexo'] = localStorage['sexo'];
        arrDatos['ano_ncto'] = localStorage['ano_ncto'];
        arrDatos['ciudad_residencia'] = localStorage['municipio'];
        arrDatos['lat'] = $('#lat').val();
        arrDatos['long'] = $('#long').val();
        arrDatos['localidad'] = $('#localidad').val();
        arrDatos['fecha_hora'] = anyo + "-" + mes + "-" + dia + " " + hora + ":" + minutos + ":" + segundos;
        arrDatos['imagen'] = app.foto;

        for (var i in app.preguntas) {
            var pregunta = app.preguntas[i];

            for (var o in pregunta) {
                //alert(o + ' - ' + pregunta[o]);

                for (var u in pregunta[o].respuestas) {
                    alert(u + ' - ' + pregunta[o].respuestas[u].idrespuesta);
                }
            }

            if(pregunta.tiporesp == 'escala' || pregunta.tiporesp == 'radiobutton')
            {
               // alert($('input:radio[name=preg_'+ pregunta.idpregunta+']:checked').val());
                //if($('input:radio[name=preg_'+ pregunta.idpregunta+']:checked').val()) {
                    arrDatos['preg' + pregunta.idpregunta] = $('input[name=preg_'+pregunta.idpregunta+']:checked').val();
                //}
            } else {
                if(pregunta.tiporesp == 'checkbox') {
                    /*for (var j=0 ; j<pregunta.respuestas.length; j++){
                        alert(pregunta.respuestas[j].idrespuesta);
                        alert($('#'+ pregunta.respuestas[j].idrespuesta).prop('checked'));
                        if($('#'+ pregunta.respuestas[j].idrespuesta).prop('checked')) {
                            arrDatos['preg_'+pregunta.idpregunta+'resp_' + pregunta.respuestas[j].idrespuesta] = 1;
                        } else {
                            arrDatos['preg_'+pregunta.idpregunta+'resp_' + pregunta.respuestas[j].idrespuesta] = 0;
                        }
                    }*/
                    //alert('input[name=preg_'+pregunta.idpregunta+']');
                    $('input[name="preg_'+pregunta.idpregunta+'[]"]').each(function(ind,val){
                        //alert('aki');
                        //alert($(this).prop('checked'));
                        if($(this).prop('checked')) {
                            arrDatos['preg' + pregunta.idpregunta+'_'+$(this).prop('id')] = 1;
                        } else {
                            arrDatos['preg' + pregunta.idpregunta+'_'+$(this).prop('id')] = 0;
                        }
                        //alert('val:'+val);
                    })
                   // "preg_'+datos[i].idpregunta+'[]"
                } else {
                    arrDatos['preg' + pregunta.idpregunta] = $('textarea[name='+'preg_'+pregunta.idpregunta+']').val();
                }
            }
            
            //alert('preg_'+pregunta.idpregunta+ ' - '+$('input[name='+'preg_'+pregunta.idpregunta+']').val());
        }

        /*
        for(var i in arrDatos) {
            alert(i+ ' - '+ arrDatos[i]);
        }
        
        strDatos = '{';
        sep = '';
        for (var i in arrDatos)
        {

            strDatos+=sep+" '"+i+"' : '"+arrDatos[i]+"' ";
            sep =',';
           
        }
        strDatos+='}';
        */

        var otroArray = jQuery.makeArray(arrDatos);
        strDatos = JSON.stringify(otroArray);
        
        $.ajax({
            url: "http://city4all.xyz/City4All/es/enviar-resultados.php",
            //url: "http://localhost/City4All/es/enviar-resultados.php",
            data: { datos: strDatos },
            //type : 'GET',
            jsonp: "callback",
            dataType: "jsonp",
            success: function(resp) {
              alert(resp);
            },
            error: function(xhr, status, text) {
                alert(text);
            }
        })
    },
    modificarIdioma : function() {
        if(window.localStorage["idioma"] == "es") {
            $('#idioma-espanol').prop('checked', true);
        } else {
            if(window.localStorage["idioma"] == "eu") {
                $('#idioma-euskara').prop('checked', true);
            } else {
                $('#idioma-english').prop('checked', true);
            }
        }
    },
    guardarIdioma : function() {
        if($('input:radio[name=idioma]:checked').val() == undefined) {
            return false;
        }
        localStorage.setItem("idioma", $('input:radio[name=idioma]:checked').val());

        if(localStorage['idioma']!=localStorage['file_lang'])
        {
            localStorage.setItem('file_lang', localStorage['idioma']); 
            if(localStorage['idioma']=='es')
            {
                window.location='./index.html';
            }
            else
            {
               window.location='./index-'+localStorage['idioma']+'.html'; 
            }
        }
    },
    accederCamara : function() {
        var cameraOptions = { 
            quality : 50,
            destinationType : Camera.DestinationType.DATA_URL,
            sourceType : Camera.PictureSourceType.CAMERA,
            allowEdit : true,
            encodingType: Camera.EncodingType.JPEG,
            targetWidth: 1000,
            targetHeight: 1000,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false 
        };
 
        navigator.camera.getPicture(function(imageURI) {

            app.foto = 'data:image/jpeg;base64,'+imageURI;

            $("#imagen").prop("src", app.foto);

        }, function(err) {

      // Mensaje de error...

        }, cameraOptions);
    },
    accederGaleria : function() {
        var cameraOptions = { 
            quality : 50,
            destinationType : Camera.DestinationType.DATA_URL,
            sourceType : Camera.PictureSourceType.PHOTOLIBRARY,
            allowEdit : true,
            encodingType: Camera.EncodingType.JPEG,
            targetWidth: 1000,
            targetHeight: 1000,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false 
        };
 
        navigator.camera.getPicture(function(imageURI) {

            app.foto = 'data:image/jpeg;base64,'+imageURI;

            $("#imagen").prop("src", app.foto);

        }, function(err) {

      // Mensaje de error...

        }, cameraOptions);
    },
    filtrar : function() {
        var experiencia = $("#experiencia").val();
        var edad = $("#edad").val();
        var meses = $("#tiempo").val();
        //alert(meses);
        var hoy = new Date();

        for(var i in app.arrPuntos) {
            var visible = true;
            //alert(experiencia+ ' - '+gestion_mapa.arrPuntos[i]['codigo']);
            
            if(experiencia == "seguras" && app.arrPuntos[i]['codigo'] <= 3) {
                visible = false;
            } 
            else if(experiencia == "neutras" && app.arrPuntos[i]['codigo'] != 3) {
                visible = false;
            }
            else if(experiencia == "inseguras" && app.arrPuntos[i]['codigo'] > 2) {
                visible = false;
            }
            
            if(edad == "18" && app.arrPuntos[i]['edad'] > 25) {
                visible = false;
            } 
            else if(edad == "26" && (app.arrPuntos[i]['edad'] < 26 || app.arrPuntos[i]['edad'] > 65)) {
                visible = false;
            } 
            else if(edad == "65" && app.arrPuntos[i]['edad'] < 66) {
                visible = false;
            }
            /*
            var fecha = new Date().toISOString().slice(0, 10);
            alert("Fecha de hoy: " + fecha);

            if(meses == "12") {
                //fecha_hoy = Fecha.getDate() + "/" + (Fecha.getMonth() +1) + "/" + Fecha.getFullYear();
                //var fecha = new Date();
                fecha.setDate(fecha.getDate()-parseInt(365));
                //fecha.format("YYYY-MM-DD");
            } else if(meses == "6") {
                fecha.setDate(fecha.getDate()-parseInt(180));
            } else if(meses == "3") {
                fecha.setDate(fecha.getDate()-parseInt(90));
            }
            alert("Fecha calculada: " + fecha);
            var fecha_calc = gestion_mapa.arrPuntos[i]['fecha_hora'];
            if(gestion_mapa.arrPuntos[i]['fecha_hora'] < fecha) {
                visible = false;
            }
            */
            app.arrPuntos[i]['marker'].setVisible(visible);
                
        }
    },
    getLanguage : function()
    {
        var lang = navigator.language || navigator.browserLanguage || false;
        if(lang)
        {
            lang= lang.substring(0,2);
        }
        return lang ;
    },
};

app.initialize();

